<?php
set_include_path(dirname(__FILE__) . '/..' . PATH_SEPARATOR . get_include_path());

if (!defined("EgoiApiFactory")) {
	define("EgoiApiFactory",0);
	
	require_once "Api.php";
	require_once "RestImpl.php";
	require_once "SoapImpl.php";
	require_once "XmlRpcImpl.php";
	
	abstract class EgoiApiFactory {
	
		function getApi($protocol) {
			switch($protocol) {
				case Protocol::Rest:
					return new EgoiApiRestImpl();
				case Protocol::Soap;
					return new EgoiApiSoapImpl();
				case Protocol::XmlRpc:
					return new EgoiApiXmlRpcImpl();
			}
		}
	
	}
	
}
?>