<?php

    class LAMailRelayWrapper {
        const API_URL = '/ccm/admin/api/version/2/&type=json';
        var $apiHost;
        var $apiKey;

        public function __construct($apiHost, $apiKey){
            $apiHost = preg_replace ( '/https?\:\/\//i', '', $apiHost); // remove protocol
            $this -> apiHost = $apiHost;
            $this -> apiKey = $apiKey;
        }

        function getMailingLists(){
            $curl = $this -> getCurl();
            $params = array('function' => 'getGroups', 'apiKey' => $this -> apiKey);
            curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($params));
            $result = curl_exec($curl);
            return json_decode($result, true);
        }

        function addSubscriber($groupId, $email, $name){
            $curl = $this -> getCurl();
            $params = array('function' => 'addSubscriber',
                            'apiKey' => $this -> apiKey,
                            'email' => $email,
                            'name' => $name,
                            'groups' => array($groupId)
                            );
            curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($params));
            $result = curl_exec($curl);
            return json_decode($result, true);
        }

        private function getCurl(){
            $url = 'https://'. $this -> apiHost .'/ccm/admin/api/version/2/&type=json';
            $curl = curl_init($url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($curl, CURLOPT_SSLVERSION, 3);
            $headers = array('X-Request-Origin: Wordpress|NKS-Subscription');
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            return $curl;
        }

    }
?>