<?php

require_once(plugin_dir_path( __FILE__ ).'include/nksub_ml_settings_proxy.php');
require_once(plugin_dir_path( __FILE__ ).'include/nksub_mailing_list_wrapper.php');
if(!class_exists('AWeberAPI')) include_once('vendor/aweber_api/aweber.php');

//add_action( 'admin_init', 'nksub_register_settings' );

function nksub_register_settings() {

	$options = nksub_get_options();
	//register_setting( 'nksub_options', 'nksub_options', 'nksub_options_validate' );

	add_settings_section('nksub_sidebar', 'General', 'nksub_colors_text', 'nksub_options');

	add_settings_field('nksub_test_mode', "Test mode during setup", 'nksub_test_mode_str', 'nksub_options', 'nksub_sidebar');
	add_settings_field('nksub_sidebar_type', "The way sidebar appears:", 'nksub_sidebar_type_str', 'nksub_options', 'nksub_sidebar');
	add_settings_field('nksub_sidebar_pos', "Sidebar position:", 'nksub_sidebar_pos_str', 'nksub_options', 'nksub_sidebar');
	add_settings_field('nksub_display', "General display rules:", 'nksub_display_str', 'nksub_options', 'nksub_sidebar');
	add_settings_field('nksub_fade_content', "Fade out main content when sidebar is exposed:", 'nksub_fade_content_str', 'nksub_options', 'nksub_sidebar');
//	add_settings_field('nksub_enable_test', "Human Test:", 'nksub_enable_test_str', 'nksub_options', 'nksub_sidebar');
//	add_settings_field('nksub_use_admin_email', "Use admin email as message sender (when hosting restricts sending emails from another domains):", 'nksub_use_admin_email_str', 'nksub_options', 'nksub_sidebar');
	add_settings_field('nksub_togglers', "Additional element to toggle Form (valid CSS selector like #id or .class):", 'nksub_togglers_str', 'nksub_options', 'nksub_sidebar');

	add_settings_section('nksub_mailing', 'Mailing', 'nksub_colors_text', 'nksub_options');
	add_settings_field('nksub_mail_type', "Send opt-ins to:", 'nksub_mail_type_str', 'nksub_options', 'nksub_mailing');
	// email
	add_settings_field('nksub_email', "Email (separated by comma if multiple):", 'nksub_email_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_email">', 'after' => '</div>'));
	// mailchimp
	add_settings_field('nksub_mc_key', "MailChimp API key (required):", 'nksub_mc_key_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_mc">'));
	add_settings_field('nksub_mc_list_id', "MailChimp list", 'nksub_mc_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
	// get response
	add_settings_field('nksub_gr_key', "Get Response API key (required):", 'nksub_gr_key_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_gr">'));
	add_settings_field('nksub_gr_list_id', "Get Response list", 'nksub_gr_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
	// constant contact
	add_settings_field('nksub_cc_user', "Constant Contact username (required):", 'nksub_cc_user_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_cc">'));
	add_settings_field('nksub_cc_pass', "Constant Contact password (required)", 'nksub_cc_pass_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_cc_list_id', "Constant Contact list", 'nksub_cc_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
	// iContact
	add_settings_field('nksub_ic_user', "iContact username (required):", 'nksub_ic_user_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_ic">'));
	add_settings_field('nksub_ic_app', "iContact App ID (required)", 'nksub_ic_app_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_ic_pass', "iContact API Password (required)", 'nksub_ic_pass_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_ic_list_id', "iContact list", 'nksub_ic_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
    // BenchmarkMail
    add_settings_field('nksub_bm_user', "Benchmark Mail username (required):", 'nksub_bm_user_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_bm">'));
    add_settings_field('nksub_bm_pass', "Benchmark Mail Password (required)", 'nksub_bm_pass_str', 'nksub_options', 'nksub_mailing');
    add_settings_field('nksub_bm_list_id', "Benchmark Mail list", 'nksub_bm_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
    // MyMail
    add_settings_field('nksub_mm_list_id', "MyMail list", 'nksub_mm_lists_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_mm">', 'after' => '</div>'));
    // AWeber
    add_settings_field('nksub_aw_auth_code', "AWeber Authorization Code (required):", 'nksub_aw_auth_code_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_aw">', 'after' => '<a target="_blank" href="https://auth.aweber.com/1.0/oauth/authorize_app/ef5155ec">Get the code</a>'));
    add_settings_field('nksub_aw_list_id', "AWeber list", 'nksub_aw_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));
	// MailPoet
	add_settings_field('nksub_mp_list_id', "MailPoet list", 'nksub_mp_lists_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_mp">', 'after' => '</div>'));

	add_settings_section('nksub_form_settings', 'Forms', 'nksub_colors_text', 'nksub_options');
	add_settings_field('nksub_forms', "Forms", 'nksub_forms_str', 'nksub_options', 'nksub_form_settings', array('hidden' => true));

	// MailRelay
	add_settings_field('nksub_mr_api_host', "MailRelay API Host (required):", 'nksub_mr_api_host_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_mr">'));
	add_settings_field('nksub_mr_api_key', "MailRelay API Key (required):", 'nksub_mr_api_key_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_mr_list_id', "MailRelay List (required):", 'nksub_mr_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));

	// E-Goi
	add_settings_field('nksub_eg_api_key', "E-Goi API Key (required):", 'nksub_eg_api_key_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_eg">'));
	add_settings_field('nksub_eg_list_id', "E-Goi List (required):", 'nksub_eg_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));

	// MadMimi
	add_settings_field('nksub_mmi_api_username', "MadMimi API Username or Email (required):", 'nksub_mmi_api_username_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_mmi">'));
	add_settings_field('nksub_mmi_api_key', "MadMimi API Key (required):", 'nksub_mmi_api_key_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_mmi_list_id', "MadMimi List (required):", 'nksub_mmi_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));

	// CampaignMonitor
	add_settings_field('nksub_cm_api_client_id', "CampaignMonitor Client ID (required):", 'nksub_cm_api_client_id_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_cm">'));
	add_settings_field('nksub_cm_api_key', "CampaignMonitor Client's API Key (required):", 'nksub_cm_api_key_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_cm_list_id', "CampaignMonitor List (required):", 'nksub_cm_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));

	// FreshMail
	add_settings_field('nksub_fm_api_key', "FreshMail API Key (required):", 'nksub_fm_api_key_str', 'nksub_options', 'nksub_mailing', array('before' => '<div id="block_fm">'));
	add_settings_field('nksub_fm_api_secret', "FreshMail API Secret (required):", 'nksub_fm_api_secret_str', 'nksub_options', 'nksub_mailing');
	add_settings_field('nksub_fm_list_id', "FreshMail List (required):", 'nksub_fm_lists_str', 'nksub_options', 'nksub_mailing', array('after' => '</div>'));

	//browser()->log('NKSUB');
	//browser()->log($options);

	for ($i = 1; $i <= $options['nksub_forms']; $i++) {

		add_settings_field('nksub_form_status_' . $i, "Status", 'nksub_form_status_str', 'nksub_options', 'nksub_form_settings', array('hidden' => true, 'index' => $i));

		if ($options['nksub_form_status_' . $i] == 'deleted') {
			continue;
		}

//		add_settings_field('nksub_email_' . $i, "Email address to send messages to (separate by comma if multiple):", 'nksub_email_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<div class="form-instance-wrapper" data-index=' .$i .'>'));
//		add_settings_field('nksub_email_title_' . $i, "Title for emails received from NK: Subscription (if Subject field is not used):", 'nksub_email_title_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_is_default_' . $i, "Make this form default on checked pages:", 'nksub_is_default_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<div class="form-instance-wrapper" data-index=' .$i .'>'));

		add_settings_field('nksub_theme_' . $i, "Form layout", 'nksub_layout_theme_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>Form Theming</h1>'));
		add_settings_field('nksub_base_color_' . $i, "Theme base color (for heading, input, button)", 'nksub_base_color_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_gamma_' . $i, "Secondary texts and elements gamma", 'nksub_gamma_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_bg_color_' . $i, "Theme solid background color", 'nksub_bg_color_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_image_bg_' . $i, 'Choose background image:', 'nksub_image_bg_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_custom_bg_' . $i, 'Your custom background:', 'nksub_custom_bg_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_show_lining_' . $i, "Wrap form in container (good when you use image background):", 'nksub_show_lining_str', 'nksub_options','nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_lining_bg_' . $i, "Container color:", 'nksub_lining_bg_str', 'nksub_options','nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_show_icons_' . $i, "Show icons for fields:", 'nksub_show_icons_str', 'nksub_options','nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_pic_' . $i, 'Theme picture or logo (will be CSS resized to 115x115 px, use square images and minimum 2x dimensions for retina):', 'nksub_pic_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));

		add_settings_field('nksub_heading_' . $i, 'Main text header:', 'nksub_heading_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>Content Settings</h1>'));
		add_settings_field('nksub_subheading_' . $i, 'Message subheader:', 'nksub_subheading_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_cta_' . $i, 'Call to action button text (if supported by theme):', 'nksub_cta_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_notice_' . $i, 'Notice to user:', 'nksub_notice_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_additional_fields_' . $i, "Additional fields (be aware that not all mailing services support these fields)", 'nksub_additional_fields_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));

		add_settings_field('nksub_form_show_' . $i, 'Appearance logic:', 'nksub_form_show_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>How Form Appears</h1>'));
		add_settings_field('nksub_form_timeout_' . $i, 'Timeout after page loads:', 'nksub_form_timeout_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_form_scroll_' . $i, 'Scroll rule:', 'nksub_form_scroll_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_sel_after_' . $i, 'Scroll rule:', 'nksub_colors_text', 'nksub_options', 'nksub_form_settings', array('hidden' => true));
		add_settings_field('nksub_sel_before_' . $i, 'Scroll rule:', 'nksub_colors_text', 'nksub_options', 'nksub_form_settings', array('hidden' => true));
		add_settings_field('nksub_sel_percent_' . $i, 'Scroll rule:', 'nksub_colors_text', 'nksub_options', 'nksub_form_settings', array('hidden' => true));
		add_settings_field('nksub_form_interval_' . $i, 'Show form with this interval until user subscribes (for page load and scroll settings):', 'nksub_form_interval_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>Displaying interval</h1>'));
		add_settings_field('nksub_form_days_' . $i, 'Days to store cookie:', 'nksub_form_days_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));

		add_settings_field('nksub_form_locker_' . $i, 'Lock form closing until user subscribes:', 'nksub_form_locker_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>Interaction Settings</h1>'));
		add_settings_field('nksub_callback_' . $i, 'JavaScript code to execute when user subscribed, eg. GA tracking (syntax errors here can break plugin):', 'nksub_callback_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_form_redirect_' . $i, 'Redirect user after subscription (leave empty to not redirect):', 'nksub_form_redirect_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_form_close_' . $i, 'Automatically close form after subscription:', 'nksub_form_close_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));

		add_settings_field('nksub_facebook_' . $i, "Facebook URL:", 'nksub_facebook_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'before' => '<h1>Social Settings</h1>'));
		add_settings_field('nksub_twitter_' . $i, "Twitter URL:", 'nksub_twitter_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_pinterest_' . $i, "Pinterest URL:", 'nksub_pinterest_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_youtube_' . $i, "YouTube URL:", 'nksub_youtube_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_instagram_' . $i, "Instagram URL:", 'nksub_instagram_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_linkedin_' . $i, "Linkedin URL:", 'nksub_linkedin_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_gplus_' . $i, "Google Plus URL:", 'nksub_gplus_str', 'nksub_options', 'nksub_form_settings', array('index' => $i));
		add_settings_field('nksub_rss_' . $i, "RSS URL:", 'nksub_rss_str', 'nksub_options', 'nksub_form_settings', array('index' => $i, 'after' => '</div>'));
	}

//	add_settings_section('nksub_theme', 'Theme', 'nksub_colors_text', 'nksub_options');

//	add_settings_field('nksub_pic_style', "Profile picture style:", 'nksub_pic_style_str', 'nksub_options', 'nksub_theme');
//	add_settings_field('nksub_invert_style', "Button style:", 'nksub_invert_style_str', 'nksub_options', 'nksub_theme');
//	add_settings_field('nksub_show_social', "Show social bar:", 'nksub_show_social_str', 'nksub_options', 'nksub_theme');
//	add_settings_field('nksub_flat_socialbar', 'Social bar position:', 'nksub_flat_socialbar_str', 'nksub_options', 'nksub_theme');
//	add_settings_field('nksub_rgba', "Rgba", 'nksub_rgba_str', 'nksub_options', 'nksub_theme', array('hidden' => true));

	add_settings_section('nksub_button', 'Button', 'nksub_colors_text', 'nksub_options');
	add_settings_field('nksub_label_color', "Button color:", 'nksub_label_color_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_style', "Button icon:", 'nksub_label_style_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_shape', "Button shape:", 'nksub_label_shape_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_size', "Button size:", 'nksub_label_size_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_tooltip', "Button tooltip:", 'nksub_label_tooltip_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_tooltip_text', "Button tooltip text:", 'nksub_label_tooltip_text_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_tooltip_color', "Button tooltip color:", 'nksub_tooltip_color_str', 'nksub_options', 'nksub_button');

	add_settings_field('nksub_metro', "Metro-style shape (overrides other shapes):", 'nksub_metro_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_invert', "Button colors invert:", 'nksub_label_invert_str', 'nksub_options', 'nksub_button');
	//add_settings_field('nksub_label_stroke', "Buttons' shape stroke:", 'nksub_label_stroke_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_top', "Button vertical position 'top' margin (please enter CSS valid value for  ex. '50%' or '200px'):", 'nksub_label_top_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_top_mob', "CSS 'top' value for mobiles:", 'nksub_label_top_mob_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_vis', "Button visibility:", 'nksub_label_vis_str', 'nksub_options', 'nksub_button');
	add_settings_field('nksub_label_mouseover', "Mouseover opening:", 'nksub_label_mouseover_str', 'nksub_options', 'nksub_button');

	add_settings_section('nksub_css', 'CSS', 'nksub_colors_text', 'nksub_options');
	add_settings_field('nksub_custom_css', "Custom CSS (stored during updates):", 'nksub_custom_css_str', 'nksub_options', 'nksub_css');
//	add_settings_section('nksub_other', 'Other', 'nksub_colors_text', 'nksub_options');

	add_settings_section('nksub_stats', 'Statistics', 'nksub_colors_text', 'nksub_options');
	add_settings_field('nksub_counters', "Your active forms statistics:", 'nksub_counters_str', 'nksub_options', 'nksub_stats');

}

function nksub_colors_text() {
}

function nksub_counters_str() {

	$options = nksub_get_options();
	$counters = $options['counters'];
	$arr = array();

	echo '<table><thead><tr><th>Form</th><th>Views</th><th>Subscriptions</th><th>Conversion</th><th>Export CSV</th></tr></thead><tbody>';

//	browser()->log  ( 'counters' );
//	browser()->log  ( $counters );

	for ($i = 0, $len = count($counters); $i < $len; $i++) {
		$id = $counters[$i]->form_id;
		$arr[$id] = array(
			'views' => $counters[$i]->views,
			'submits' => $counters[$i]->submits
		);
	}

//	browser()->log  ( $arr );


	for ($i = 1; $i <= $options['nksub_forms']; $i++) {

		if ($options['nksub_form_status_' . $i] !== 'deleted') {

//			browser()->log  ( 'id' );
//			browser()->log  ( $i );

			if (isset($arr[$i])) {
				$views = intval($arr[$i]['views']);
				$submits = intval($arr[$i]['submits']);

				$conversion = $submits === 0 ? 0 : $submits * 100 / $views;
				$conversion = intval($conversion);
				echo '<tr><td>#' . $i . ' </td><td>' . $arr[$i]['views'] . '</td><td>' . $submits . '</td><td>' . $conversion . '%</td><td><a class="download" href="' .admin_url() . 'admin-ajax.php?action=nksub_get_subscribers_csv&form_id='. $i .'">Download</a></td></tr>';
			} else {
				echo '<tr><td>#' . $i . ' </td><td>0</td><td>0</td><td>0%</td><td><a class="download" href="' .admin_url() . 'admin-ajax.php?action=nksub_get_subscribers_csv&form_id='. $i .'">Download</a></td></tr>';
			}

		}
	}

	echo '</tbody></table>';

}

function nksub_display_str() {
	$options = nksub_get_options();
	$user_opts = json_decode($options['nksub_display']);
	$locations = $options['locations'];
	//browser()->log('tab ' .$index . ' opts');
	//browser()->log($user_opts);

	?>
	<p>
		<input id='nksub_display' name='nksub_options[nksub_display]' type='hidden' value='<?php echo $options['nksub_display']?>' />
	<div class='loc_popup'>
		<p>
			<label for="nksub_user_status"><?php _e('Show Form for:', 'nk-sub') ?></label>
			<select name="display_user_status" id="nksub_user_status" class="widefat">
				<option value="everyone" <?php echo selected( $user_opts->user->everyone, '1' ) ?>><?php _e('Everyone', 'nk-sub') ?></option>
				<option value="loggedout" <?php echo selected( $user_opts->user->loggedout, '1' ) ?>><?php _e('Logged-out users', 'nk-sub') ?></option>
				<option value="loggedin" <?php echo selected( $user_opts->user->loggedin, '1' ) ?>><?php _e('Logged-in users', 'nk-sub') ?></option>
			</select>
		</p>

		<p>
			<label for="nksub_display_mobile"><?php _e('Show on mobiles:', 'nk-sub') ?></label>
			<select name="display_mobile" id="nksub_display_mobile" class="widefat">
				<option value="yes" <?php echo selected( $user_opts->mobile->yes, '1' ) ?>><?php _e('Show', 'nk-sub') ?></option>
				<option value="no" <?php echo selected( $user_opts->mobile->no, '1' ) ?>><?php _e('Don\'t show', 'nk-sub') ?></option>
			</select>
		</p>

		<p>
			<label for="nksub_user_status"><?php _e('Display rule:', 'nk-sub') ?></label>

			<select name="display_rule" id="display_rule" class="widefat">
				<option value="exclude" <?php echo selected( $user_opts->rule->exclude, '1' ) ?>><?php _e('Hide on checked pages', 'nk-sub') ?></option>
				<option value="include" <?php echo selected( $user_opts->rule->include, '1' ) ?>><?php _e('Show on checked pages', 'nk-sub') ?></option>
			</select>
		</p>

		<div style="height:150px; overflow:auto; border:1px solid #dfdfdf; padding:5px; margin-bottom:5px;">
			<h4 class="dw_toggle" style="cursor:pointer;margin-top:0;"><?php _e('Default WP pages', 'nk-sub') ?></h4>
			<div class="dw_collapse">
				<?php foreach ($locations->wp_pages as $key => $label){
					?>
					<p><input class="checkbox" type="checkbox" value="<?php echo $key?>" <?php checked(isset($user_opts->location->wp_pages->$key) ? $user_opts->location->wp_pages->$key : false, true) ?> id="display_wp_page_<?php echo $key?>" name="display_wp_page_<?php echo $key?>" />
						<label for="display_wp_page_<?php echo $key?>"><?php echo $label .' '. __('Page', 'nk-sub') ?></label></p>
				<?php
				}
				?>
			</div>

			<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Pages') ?></h4>
			<div class="dw_collapse">
				<?php foreach ( $locations->pages as $page ) {
					//$instance['page-'. $page->ID] = isset($instance['page-'. $page->ID]) ? $instance['page-'. $page->ID] : false;
					$id = $page->ID;
					$p_title = apply_filters('the_title', $page->post_title, $page->ID);
					if ( isset($page->post_parent) ) {
						$parent = get_post($page->post_parent);

						$p_title .= ' ('. apply_filters('the_title', $parent->post_title, $parent->ID);

						if ( $parent->post_parent ) {
							$grandparent = get_post($parent->post_parent);
							$p_title .= ' - '. apply_filters('the_title', $grandparent->post_title, $grandparent->ID);
							unset($grandparent);
						}
						$p_title .= ')';

						unset($parent);
					}
					//browser()->log($p_title);

					?>
					<p><input class="checkbox" type="checkbox" value="<?php echo $id?>" <?php checked(isset($user_opts->location->pages->$id), true) ?> id="display_page_<?php echo $id ?>" name="display_page_<?php echo $id ?>" />
						<label for="display_page_<?php echo $id?>"><?php echo $p_title ?></label></p>
					<?php   unset($p_title);
				}  ?>
			</div>

			<?php if ( !empty($locations->cposts) ) { ?>
				<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Custom Post Types', 'nk-sub') ?> +/-</h4>
				<div class="dw_collapse">
					<?php foreach ( $locations->cposts as $post_key => $custom_post ) {
						?>
						<p><input class="checkbox" type="checkbox" value="<?php echo $post_key?>" <?php checked(isset($user_opts->location->cposts->$post_key), true) ?> id="display_cpost_<?php echo $post_key?>" name="display_cpost_<?php echo $post_key?>" />
							<label for="display_cpost_<?php echo $post_key?>"><?php echo stripslashes($custom_post->labels->name) ?></label></p>
						<?php
						unset($post_key);
						unset($custom_post);
					} ?>
				</div>

				<!--<h4 class="dw_toggle" style="cursor:pointer;"><?php /*_e('Custom Post Type Archives', 'nk-sub') */?> +/-</h4>
				<div class="dw_collapse">
					<?php /*foreach ( $this->cposts as $post_key => $custom_post ) {
						if ( !$custom_post->has_archive ) {
							// don't give the option if there is no archive page
							continue;
						}
						$instance['type-'. $post_key .'-archive'] = isset($instance['type-'. $post_key .'-archive']) ? $instance['type-'. $post_key .'-archive'] : false;
						*/?>
						<p><input class="checkbox" type="checkbox" <?php /*checked($instance['type-'. $post_key.'-archive'], true) */?> id="<?php /*echo $widget->get_field_id('type-'. $post_key .'-archive'); */?>" name="<?php /*echo $widget->get_field_name('type-'. $post_key .'-archive'); */?>" />
							<label for="<?php /*echo $widget->get_field_id('type-'. $post_key .'-archive'); */?>"><?php /*echo stripslashes($custom_post->labels->name) */?> <?php /*_e('Archive', 'nk-sub') */?></label></p>
					<?php /*} */?>
				</div>-->
			<?php } ?>

			<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Categories') ?></h4>
			<div class="dw_collapse">
				<?php foreach ( $locations->cats as $cat ) {
					$catid = $cat->cat_ID;
					?>
					<p><input class="checkbox" type="checkbox"  value="<?php echo $catid?>" <?php checked(isset($user_opts->location->cats->$catid), true) ?> id="display_cat_<?php echo $catid?>" name="display_cat_<?php echo $catid?>" />
						<label for="display_cat_<?php echo $catid?>"><?php echo $cat->cat_name ?></label></p>
					<?php
					unset($cat);
				}
				?>
			</div>

			<?php /*if ( !empty($this->taxes) ) { */?><!--
				<h4 class="dw_toggle" style="cursor:pointer;"><?php /*_e('Taxonomies', 'nk-sub') */?> +/-</h4>
				<div class="dw_collapse">
					<?php /*foreach ( $this->taxes as $tax ) {
						$instance['tax-'. $tax] = isset($instance['tax-'. $tax]) ? $instance['tax-'. $tax] : false;
						*/?>
						<p><input class="checkbox" type="checkbox" <?php /*checked($instance['tax-'. $tax], true) */?> id="<?php /*echo $widget->get_field_id('tax-'. $tax); */?>" name="<?php /*echo $widget->get_field_name('tax-'. $tax); */?>" />
							<label for="<?php /*echo $widget->get_field_id('tax-'. $tax); */?>"><?php /*echo str_replace(array('_','-'), ' ', ucfirst($tax)) */?></label></p>
						<?php
			/*						unset($tax);
								}
								*/?>
				</div>
			--><?php /*} */?>

			<?php if ( !empty($locations->langs) ) { ?>
				<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Languages', 'nk-sub') ?></h4>
				<div class="dw_collapse">
					<?php foreach ( $locations->langs as $lang ) {
						$key = $lang['language_code'];
						?>
						<p><input class="checkbox" type="checkbox" <?php checked(isset($user_opts->location->langs->$key), true) ?> id="display_lang_<?php echo $key?>" name="display_lang_<?php echo $key?>" value="<?php echo $key?>" />
							<label for="display_lang_<?php echo $key?>"><?php echo $lang['native_name'] ?></label></p>

						<?php
						unset($lang);
						unset($key);
					}
					?>
				</div>
			<?php } ?>

			<p><label for="display_ids"><?php _e('Comma Separated list of IDs of posts not listed above', 'nk-sub') ?>:</label>
				<input type="text" value="<?php echo implode(",", $user_opts->location->ids); ?>" name="display_ids" id="display_ids" />
			</p>
		</div>

		<button name='Submit' type='submit' id='sbmt_nksub_popup' class='display-sbmt button-primary' value='Save'>Save Display Options</i></button>

	</div>
	</p>
<?php
}

function options_for_select($options, $selected_value, $include_blank = false){
    if($include_blank){
        $out = '<option>--- Not selected ---</option>';
    }else{
        $out = '';
    }

    if (is_array($options) || is_object($options))
    {
        foreach($options as $opt){
            $selected = ($opt[0] == $selected_value) ? 'selected' : '';
            $out .= "<option value='$opt[0]' $selected>$opt[1]</option>";
        }
    }

    return $out;
}

function nksub_forms_str() {
	$options = nksub_get_options();
	echo " <input id='nksub_forms' name='nksub_options[nksub_forms]' size='40' type='hidden' value='{$options['nksub_forms']}' style='' />";
}
function nksub_form_status_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_form_status_{$index}' name='nksub_options[nksub_form_status_{$index}]' size='40' type='hidden' value='{$options['nksub_form_status_'.$index]}' style='' />";
}

function nksub_email_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_email' name='nksub_options[nksub_email]' size='40' type='text' value='{$options['nksub_email']}' style='' />";
}


function nksub_mc_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_mc_key' name='nksub_options[nksub_mc_key]' size='40' type='text' value='{$options['nksub_mc_key']}' style='' />";
}

function nksub_gr_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_gr_key' name='nksub_options[nksub_gr_key]' size='40' type='text' value='{$options['nksub_gr_key']}' style='' />";
}
function nksub_cc_user_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_cc_user' name='nksub_options[nksub_cc_user]' size='40' type='text' value='{$options['nksub_cc_user']}' style='' />";
}

function nksub_cc_pass_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_cc_pass' name='nksub_options[nksub_cc_pass]' size='40' type='password' value='{$options['nksub_cc_pass']}' style='' />";
}
function nksub_ic_pass_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_ic_pass' name='nksub_options[nksub_ic_pass]' size='40' type='password' value='{$options['nksub_ic_pass']}' style='' />";
}

function nksub_ic_user_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_ic_user' name='nksub_options[nksub_ic_user]' size='40' type='text' value='{$options['nksub_ic_user']}' style='' />";
}

function nksub_ic_app_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_ic_app' name='nksub_options[nksub_ic_app]' size='40' type='text' value='{$options['nksub_ic_app']}' style='' />";
}

function nksub_bm_user_str() {
    $options = nksub_get_options();
    echo "<input id='nksub_bm_user' name='nksub_options[nksub_bm_user]' size='40' type='text' value='{$options['nksub_bm_user']}' style='' />";
}

function nksub_bm_pass_str() {
    $options = nksub_get_options();
    echo "<input id='nksub_bm_pass' name='nksub_options[nksub_bm_pass]' size='40' type='password' value='{$options['nksub_bm_pass']}' style='' />";
}

function nksub_aw_auth_code_str() {
    $options = nksub_get_options();
    echo "<textarea id='nksub_aw_auth_code' name='nksub_options[nksub_aw_auth_code]' size='40' type='text' style=''>{$options['nksub_aw_auth_code']}</textarea>";
}

function nksub_mr_api_host_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_mr_api_host' name='nksub_options[nksub_mr_api_host]' size='40' type='text' value='{$options['nksub_mr_api_host']}' style='' />";
}

function nksub_mr_api_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_mr_api_key' name='nksub_options[nksub_mr_api_key]' size='40' type='text' value='{$options['nksub_mr_api_key']}' style='' />";
}

function nksub_eg_api_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_eg_api_key' name='nksub_options[nksub_eg_api_key]' size='40' type='text' value='{$options['nksub_eg_api_key']}' style='' />";
}

function nksub_mmi_api_username_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_mmi_api_username' name='nksub_options[nksub_mmi_api_username]' size='40' type='text' value='{$options['nksub_mmi_api_username']}' style='' />";
}

function nksub_mmi_api_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_mmi_api_key' name='nksub_options[nksub_mmi_api_key]' size='40' type='text' value='{$options['nksub_mmi_api_key']}' style='' />";
}

function nksub_cm_api_client_id_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_cm_api_client_id' name='nksub_options[nksub_cm_api_client_id]' size='40' type='text' value='{$options['nksub_cm_api_client_id']}' style='' />";
}

function nksub_cm_api_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_cm_api_key' name='nksub_options[nksub_cm_api_key]' size='40' type='text' value='{$options['nksub_cm_api_key']}' style='' />";
}

function nksub_fm_api_key_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_fm_api_key' name='nksub_options[nksub_fm_api_key]' size='40' type='text' value='{$options['nksub_fm_api_key']}' style='' />";
}

function nksub_fm_api_secret_str() {
	$options = nksub_get_options();
	echo "<input id='nksub_fm_api_secret' name='nksub_options[nksub_fm_api_secret]' size='40' type='password' value='{$options['nksub_fm_api_secret']}' style='' />";
}

function nksub_mailing_list_options($provider_name){
    $options = nksub_get_options();

	switch ($provider_name) {
		case 'mc' :
			if (empty($options['nksub_mc_key'])) return;
			break;
		case 'gr' :
			if (empty($options['nksub_gr_key'])) return;
			break;
		case 'cc' :
			if (empty($options['nksub_cc_user']) || empty($options['nksub_cc_pass'])) return;
			break;
		case 'ic' :
			if (empty($options['nksub_ic_user']) || empty($options['nksub_ic_pass'])|| empty($options['nksub_ic_app'])) return;
			break;
        case 'bm' :
            if (empty($options['nksub_bm_user']) || empty($options['nksub_bm_pass'])) return;
            break;
        case 'mm' :
            break;
		case 'mp' :
			break;
        case 'aw' :
            if (empty($options['nksub_aw_auth_code'])) return;
            break;
		case 'mr' :
			if (empty($options['nksub_mr_api_host']) || empty($options['nksub_mr_api_key'])) return;
			break;
		case 'eg' :
			if (empty($options['nksub_eg_api_key'])) return;
			break;
		case 'mmi' :
			if (empty($options['nksub_mmi_api_key'])) return;
			break;
		case 'cm' :
			if (empty($options['nksub_cm_api_key']) || empty($options['nksub_cm_api_client_id'])) return;
			break;
		case 'fm' :
			if (empty($options['nksub_fm_api_key']) || empty($options['nksub_fm_api_secret'])) return;
			break;
	}

    $lists_var = 'nksub_'.$provider_name.'_lists';
    $list_id_var = 'nksub_'.$provider_name.'_list_id';


    if(!empty($options[$lists_var])){
        $options[$lists_var] = unserialize($options[$lists_var]);
    }else{

		// we need to extract stuff from auth code here and update settings
		if($provider_name == 'aw') {
			if(!empty($options['nksub_aw_auth_code']) && $options['nksub_aw_details_for'] != $options['nksub_aw_auth_code']){
				try {
					$aweber_auth = AWeberAPI::getDataFromAweberID($options['nksub_aw_auth_code']);
					list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $aweber_auth;
					$options['nksub_aw_details_for'] = $options['nksub_aw_auth_code'];
					$options['nksub_aw_consumer_key'] = $consumerKey;
					$options['nksub_aw_consumer_secret'] = $consumerSecret;
					$options['nksub_aw_access_key'] = $accessKey;
					$options['nksub_aw_access_secret'] = $accessSecret;
				} catch(Exception $e) {
					error_log($e);
				}
			}
		}

        $settings_proxy = new LAGatsbyMLSettingsProxy($options, $provider_name);
        $mlm = new LAGatsbyMailingListWrapper($settings_proxy -> getType(), $settings_proxy -> getSettings());
        $options[$lists_var] = $mlm->getMailingLists();
    }

	if($provider_name == 'aw') {
		echo "<span style='display:none;'>";
		echo "<input  id='nksub_aw_details_for' type='hidden' name='nksub_options[nksub_aw_details_for]' value='".$options['nksub_aw_details_for']."'>";
		echo "<input  id='nksub_aw_consumer_key' type='hidden' name='nksub_options[nksub_aw_consumer_key]' value='".$options['nksub_aw_consumer_key']."'>";
		echo "<input  id='nksub_aw_consumer_secret' type='hidden' name='nksub_options[nksub_aw_consumer_secret]' value='".$options['nksub_aw_consumer_secret']."'>";
		echo "<input  id='nksub_aw_access_key' type='hidden' name='nksub_options[nksub_aw_access_key]' value='".$options['nksub_aw_access_key']."'>";
		echo "<input  id='nksub_aw_access_secret' type='hidden' name='nksub_options[nksub_aw_access_secret]' value='".$options['nksub_aw_access_secret']."'>";
		echo "</span>";
	}

	if ( !isset( $options[$lists_var] ) || !isset($options[$list_id_var])) return;

    $options_for_select = options_for_select($options[$lists_var], $options[$list_id_var]);

    if(count($options[$lists_var]) > 0){
        echo "<input  id='$lists_var' type='hidden' name='nksub_options[$lists_var]' value='".serialize($options[$lists_var])."'>";
        echo "<select id='$list_id_var' name='nksub_options[$list_id_var]'>$options_for_select</select>";
        echo "&nbsp;<button class='display-sbmt button-primary nksub_reset_lists_data' data-target-input='$lists_var'>Reload</button>";
    }

}

function nksub_mc_lists_str()
{
    nksub_mailing_list_options('mc');
}

function nksub_gr_lists_str()
{
    nksub_mailing_list_options('gr');
}

function nksub_cc_lists_str()
{
    nksub_mailing_list_options('cc');
}

function nksub_ic_lists_str()
{
    nksub_mailing_list_options('ic');
}

function nksub_bm_lists_str()
{
    nksub_mailing_list_options('bm');
}

function nksub_mm_lists_str()
{
    nksub_mailing_list_options('mm');
}

function nksub_aw_lists_str()
{
    nksub_mailing_list_options('aw');
}

function nksub_mp_lists_str()
{
	nksub_mailing_list_options('mp');
}

function nksub_mr_lists_str()
{
	nksub_mailing_list_options('mr');
}

function nksub_eg_lists_str()
{
	nksub_mailing_list_options('eg');
}

function nksub_mmi_lists_str()
{
	nksub_mailing_list_options('mmi');
}

function nksub_cm_lists_str()
{
	nksub_mailing_list_options('cm');
}

function nksub_fm_lists_str()
{
	nksub_mailing_list_options('fm');
}

function nksub_additional_fields_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$fields = json_decode($options['nksub_additional_fields_'.$index], true);

	$first_checked = !empty($fields['name']) ? 'checked="checked"' : '';
	$sec_checked = !empty($fields['phone']) ? 'checked="checked"' : '';
	$third_checked = !empty($fields['city']) ? 'checked="checked"' : '';
	$forth_checked = !empty($fields['subject']) ? 'checked="checked"' : '';
	echo "
			<p>
				<input id='nksub_additional_name_{$index}' name='nksub_options[nksub_additional_name_{$index}]' type='checkbox' value='yes' {$first_checked} style='' /> <label for='nksub_additional_name_{$index}'><strong>Name</strong> field</label><br/>
				<input id='nksub_additional_phone_{$index}' name='nksub_options[nksub_additional_phone_{$index}]' type='checkbox' value='yes' {$sec_checked} style='' /> <label for='nksub_additional_phone_{$index}'><strong>Phone</strong> field</label><br/>
				<input id='nksub_additional_city_{$index}' name='nksub_options[nksub_additional_city_{$index}]' type='checkbox' value='yes' {$third_checked} style='' /> <label for='nksub_additional_city_{$index}'><strong>City</strong> field</label>
			</p>

			<input type='hidden' id='nksub_additional_fields_{$index}' name='nksub_options[nksub_additional_fields_{$index}]' value='{$options['nksub_additional_fields_'.$index]}'>
	<script>
	jQuery('.settings-form-row.nksub_additional_fields_{$index} input').change(function() {
		var t = jQuery(this);
		var id = t.attr('id').replace('nksub_additional_', '').replace(/\_\d*/, '');
		console.log(id);
		var val = jQuery(this).val();
		var storage = JSON.parse(jQuery('#nksub_additional_fields_{$index}').val());
		if (this.checked) {
			storage[id] = true;
		} else {
			storage[id] = false;
		}
		jQuery('#nksub_additional_fields_{$index}').val(JSON.stringify(storage))

    console.log(JSON.stringify(storage))
	});
	</script>
	";
}


function nksub_test_mode_str() {
	$options = nksub_get_options();
	$style = $options['nksub_test_mode'];
	$first_checked = $style == 'yes' ? 'checked="checked"' : '';
//	browser()->log('NKSUB test');
	echo "
	<p><input id='nksub_test_mode' name='nksub_options[nksub_test_mode]' type='checkbox' value='yes' {$first_checked} style='' /> <label for='nksub_test_mode'>Visible only for logged-in admins</label></p>
	";
}

function nksub_email_title_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
  echo get_bloginfo('name') . " <input id='nksub_email_title_{$index}' name='nksub_options[nksub_email_title_{$index}]' size='100' type='text' value='{$options['nksub_email_title_'.$index]}' style='' />";
}


function nksub_is_default_str($args) {
	$options = nksub_get_options();
	$locations = $options['locations'];
	$index = $args["index"];
	$user_opts = json_decode($options['nksub_is_default_' . $index]);

	//browser()->log('tab ' .$index . ' opts');
	//browser()->log($user_opts);

	?>
	<p>
		<input id='nksub_is_default_<?php echo $index?>' name='nksub_options[nksub_is_default_<?php echo $index?>]' type='hidden' value='<?php echo $options['nksub_is_default_'.$index]?>' />
	<div class='loc_popup'>

		<div style="height:150px; overflow:auto; border:1px solid #dfdfdf; padding:5px; margin-bottom:5px;">
			<h4 class="dw_toggle" style="cursor:pointer;margin-top:0;"><?php _e('Default WP pages', 'nk-sub') ?></h4>
			<div class="dw_collapse">
				<?php foreach ($locations->wp_pages as $key => $label){
					?>
					<p><input class="checkbox" type="checkbox" value="<?php echo $key?>" <?php checked(isset($user_opts->location->wp_pages->$key) ? $user_opts->location->wp_pages->$key : false, true) ?> id="display_wp_page_<?php echo $key . '_' . $index?>" name="display_wp_page_<?php echo $key . '_' . $index?>" />
						<label for="display_wp_page_<?php echo $key . '_' . $index?>"><?php echo $label .' '. __('Page', 'nk-sub') ?></label></p>
				<?php
				}
				?>
			</div>

			<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Pages') ?></h4>
			<div class="dw_collapse">
				<?php foreach ( $locations->pages as $page ) {
					//$instance['page-'. $page->ID] = isset($instance['page-'. $page->ID]) ? $instance['page-'. $page->ID] : false;
					$id = $page->ID;
					$p_title = apply_filters('the_title', $page->post_title, $page->ID);
					if ( isset($page->post_parent) ) {
						$parent = get_post($page->post_parent);

						$p_title .= ' ('. apply_filters('the_title', $parent->post_title, $parent->ID);


						if ( $parent->post_parent ) {
							$grandparent = get_post($parent->post_parent);
							$p_title .= ' - '. apply_filters('the_title', $grandparent->post_title, $grandparent->ID);
							unset($grandparent);
						}
						$p_title .= ')';

						unset($parent);
					}
					//browser()->log($p_title);

					?>
					<p><input class="checkbox" type="checkbox" value="<?php echo $id?>" <?php checked(isset($user_opts->location->pages->$id), true) ?> id="display_page_<?php echo $id . '_' . $index?>" name="display_page_<?php echo $id . '_' . $index?>" />
						<label for="display_page_<?php echo $id . '_' . $index?>"><?php echo $p_title ?></label></p>
					<?php   unset($p_title);
				}  ?>
			</div>

			<?php if ( !empty($locations->cposts) ) { ?>
				<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Custom Post Types', 'nk-sub') ?> +/-</h4>
				<div class="dw_collapse">
					<?php foreach ( $locations->cposts as $post_key => $custom_post ) {
						?>
						<p><input class="checkbox" type="checkbox" value="<?php echo $post_key?>" <?php checked(isset($user_opts->location->cposts->$post_key), true) ?> id="display_cpost_<?php echo $post_key . '_' . $index?>" name="display_cpost_<?php echo $post_key . '_' . $index?>" />
							<label for="display_cpost_<?php echo $post_key . '_' . $index?>"><?php echo stripslashes($custom_post->labels->name) ?></label></p>
						<?php
						unset($post_key);
						unset($custom_post);
					} ?>
				</div>

				<!--<h4 class="dw_toggle" style="cursor:pointer;"><?php /*_e('Custom Post Type Archives', 'nk-sub') */?> +/-</h4>
				<div class="dw_collapse">
					<?php /*foreach ( $this->cposts as $post_key => $custom_post ) {
						if ( !$custom_post->has_archive ) {
							// don't give the option if there is no archive page
							continue;
						}
						$instance['type-'. $post_key .'-archive'] = isset($instance['type-'. $post_key .'-archive']) ? $instance['type-'. $post_key .'-archive'] : false;
						*/?>
						<p><input class="checkbox" type="checkbox" <?php /*checked($instance['type-'. $post_key.'-archive'], true) */?> id="<?php /*echo $widget->get_field_id('type-'. $post_key .'-archive'); */?>" name="<?php /*echo $widget->get_field_name('type-'. $post_key .'-archive'); */?>" />
							<label for="<?php /*echo $widget->get_field_id('type-'. $post_key .'-archive'); */?>"><?php /*echo stripslashes($custom_post->labels->name) */?> <?php /*_e('Archive', 'nk-sub') */?></label></p>
					<?php /*} */?>
				</div>-->
			<?php } ?>

			<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Categories') ?></h4>
			<div class="dw_collapse">
				<?php foreach ( $locations->cats as $cat ) {
					$catid = $cat->cat_ID;
					?>
					<p><input class="checkbox" type="checkbox"  value="<?php echo $catid?>" <?php checked(isset($user_opts->location->cats->$catid), true) ?> id="display_cat_<?php echo $catid . '_' . $index?>" name="display_cat_<?php echo $catid . '_' . $index?>" />
						<label for="display_cat_<?php echo $catid . '_' . $index?>"><?php echo $cat->cat_name ?></label></p>
					<?php
					unset($cat);
				}
				?>
			</div>

			<?php /*if ( !empty($this->taxes) ) { */?><!--
				<h4 class="dw_toggle" style="cursor:pointer;"><?php /*_e('Taxonomies', 'nk-sub') */?> +/-</h4>
				<div class="dw_collapse">
					<?php /*foreach ( $this->taxes as $tax ) {
						$instance['tax-'. $tax] = isset($instance['tax-'. $tax]) ? $instance['tax-'. $tax] : false;
						*/?>
						<p><input class="checkbox" type="checkbox" <?php /*checked($instance['tax-'. $tax], true) */?> id="<?php /*echo $widget->get_field_id('tax-'. $tax); */?>" name="<?php /*echo $widget->get_field_name('tax-'. $tax); */?>" />
							<label for="<?php /*echo $widget->get_field_id('tax-'. $tax); */?>"><?php /*echo str_replace(array('_','-'), ' ', ucfirst($tax)) */?></label></p>
						<?php
			/*						unset($tax);
								}
								*/?>
				</div>
			--><?php /*} */?>

			<?php if ( !empty($locations->langs) ) { ?>
				<h4 class="dw_toggle" style="cursor:pointer;"><?php _e('Languages', 'nk-sub') ?></h4>
				<div class="dw_collapse">
					<?php foreach ( $locations->langs as $lang ) {
						$key = $lang['language_code'];
						?>
						<p><input class="checkbox" type="checkbox" <?php checked(isset($user_opts->location->langs->$key), true) ?> id="display_lang_<?php echo $key . '_' . $index?>" name="display_lang_<?php echo $index?>" value="<?php echo $key?>" />
							<label for="display_lang_<?php echo $key . '_' . $index?>"><?php echo $lang['native_name'] ?></label></p>

						<?php
						unset($lang);
						unset($key);
					}
					?>
				</div>
			<?php } ?>

			<p><label for="display_ids2"><?php _e('Comma Separated list of IDs of posts not listed above', 'nk-sub') ?>:</label>
				<input type="text" value="<?php echo implode(",", $user_opts->location->ids); ?>" name="display_ids2" id="display_ids2" />
			</p>
		</div>

		<button name='Submit' type='submit' id='sbmt_nksub_popup' class='display-sbmt button-primary' value='Save'>Save Display Options</i></button>

	</div>
	</p>
<?php
}

function nksub_base_color_str($args) {
	$options = nksub_get_options();
		$index = $args["index"];
		$basecolor = $options['nksub_base_color_' . $index];
		$theme = $options['nksub_theme_' . $index];
    $previewpic = plugins_url('/img/wolf.jpg', __FILE__);
    $previewname = 'John';
    $previewname2 = '';
    $previewlastname = 'Appleseed';
    $previewtitle = 'Blog Awesome Author';
    $previewbio = 'Hello lovely visitor! Send me a message and you will have my answer.';
		$url = plugins_url('/img', __FILE__);


    echo "<input id='nksub_base_color_{$index}' data-color-format='hex' name='nksub_options[nksub_base_color_{$index}]' type='text' value='{$options['nksub_base_color_'.$index]}' style='' />";


}

function nksub_bg_color_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];

	echo "<input id='nksub_bg_color_{$index}' data-color-format='hex' name='nksub_options[nksub_bg_color_{$index}]' type='text' value='{$options['nksub_bg_color_'.$index]}' style='' />";

}

function nksub_color_schema_str ($args) {
    $options = nksub_get_options();
		$index = $args["index"];

		echo "<input id='nksub_color_schema_{$index}' name='nksub_options[nksub_color_schema_{$index}]' type='text' value='{$options['nksub_color_schema_'. $index]}' style='' />";
}

function nksub_rgba_str () {
    $options = nksub_get_options();
    echo "<input id='nksub_rgba' name='nksub_options[nksub_rgba]' type='text' value='{$options['nksub_rgba']}' style='' />";
}

function nksub_layout_theme_str ($args) {
    $options = nksub_get_options();
		$index = $args["index"];
		$theme = $options['nksub_theme_' . $index];


		echo "
		<select id='nksub_theme_{$index}' name='nksub_options[nksub_theme_{$index}]'>
	    <option value='flat' " . ($theme === 'flat' ? 'selected="selected"' : '') . ">Flat</option>
	    <option value='classic' " . ($theme === 'classic' ? 'selected="selected"' : '') . ">Classic</option>
		  <option value='aerial' " . ($theme === 'aerial' ? 'selected="selected"' : '') . ">Aerial</option>
	  </select>
    ";

	  // <option value='minimalistic' " . ($theme === 'minimalistic' ? 'selected="selected"' : '') . ">Minimalistic</option>
}

function nksub_form_show_str ($args) {
    $options = nksub_get_options();
		$index = $args["index"];
		$opt = $options['nksub_form_show_' . $index];
		echo "
		<select id='nksub_form_show_{$index}' name='nksub_options[nksub_form_show_{$index}]'>
	    <option value='manual' " . ($opt === 'manual' ? 'selected="selected"' : '') . ">User manually opens form</option>
	    <option value='pageload' " . ($opt === 'pageload' ? 'selected="selected"' : '') . ">User manually + On page load</option>
	    <option value='scroll' " . ($opt === 'scroll' ? 'selected="selected"' : '') . ">User manually + On scroll (on conditions below)</option>
	  </select>
    ";
}function nksub_form_interval_str ($args) {
    $options = nksub_get_options();
		$index = $args["index"];
		$opt = $options['nksub_form_interval_' . $index];
		echo "
		<select id='nksub_form_interval_{$index}' name='nksub_options[nksub_form_interval_{$index}]'>
	    <option value='cookie' " . ($opt === 'cookie' ? 'selected="selected"' : '') . ">Show one time for cookie life</option>
	    <option value='session' " . ($opt === 'session' ? 'selected="selected"' : '') . ">Show one time for session</option>
	  </select>
    ";
}

function nksub_enable_test_str() {
	$options = nksub_get_options();

	if(@$options['nksub_enable_test'] == "enable") {
		$nksub_enable_test = "checked='checked'" ;
	} else {
        $nksub_enable_test = '';
    }

	echo "	<input id='nksub_enable_test' name='nksub_options[nksub_enable_test]' type='checkbox' value='enable' {$nksub_enable_test} style='' /> <label for='nksub_enable_test'>Enable simple test (math question) to help prevent spam</label><br>
	";
}

function nksub_sidebar_type_str () {
	$options = nksub_get_options();
	$checked1 = $options['nksub_sidebar_type'] === 'push' ? 'checked="checked"' : '';
	$checked2 = $options['nksub_sidebar_type'] === 'slide' ? 'checked="checked"' : '';

	echo "<p><input id='nksub_sidebar_type_push' name='nksub_options[nksub_sidebar_type]' type='radio' {$checked1} value='push' /> <label for='nksub_sidebar_type_push'>Pushing page content and revealing itself under it</label></p>";
	echo "<p><input id='nksub_sidebar_type_slide' name='nksub_options[nksub_sidebar_type]' type='radio' {$checked2} value='slide' /> <label for='nksub_sidebar_type_slide'>Sliding itself on the top of page content</label></p>";
}

function nksub_use_admin_email_str() {
	$options = nksub_get_options();

	if($options['nksub_use_admin_email'] == "enable") {
		$nksub_use_admin_email = "checked='checked'";
	} else {
		$nksub_use_admin_email = '';
	}

	echo "<input id='nksub_use_admin_email' name='nksub_options[nksub_use_admin_email]' type='checkbox' value='enable' {$nksub_use_admin_email} style='' /> <label for='nksub_use_admin_email'>Use site admin email</label><br>
	";
}

function nksub_calltoaction_str() {
	$options = nksub_get_options();
	echo " <input id='nksub_calltoaction' name='nksub_options[nksub_calltoaction]' size='40' type='text' value='{$options['nksub_calltoaction']}' style='' />";
}

function nksub_success_message_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];

	echo " <input id='nksub_success_message_{$index}' name='nksub_options[nksub_success_message_{$index}]' size='100' type='text' value='{$options['nksub_success_message_' . $index]}' style='' />
	";
}

function nksub_pic_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo '<p>* In flat and aerial layouts picture will be underneath heading</p>';
	if (empty($options['nksub_pic_'.$index])) {
		echo "<input id='nksub_pic_file_" . $index . "' type='file' name='nksub_pic_{$index}' value='{$options['nksub_pic_'.$index]}' /> <input name='Submit' type='submit' class='button-primary' value='Upload' />";
	} else {
		echo '<div class="nksub_pic"><img width="115" height="115" src="' . $options['nksub_pic_'.$index] . '" alt=""/></div>';
		echo '<p><input  style="margin-top: 0;" type="submit" data-id="' . $index . '" class="button-secondary" id="nksub_remove_pic_'. $index . '" value="Remove this pic"/></p>';
		echo "<span>...or upload new one</span><br><input id='nksub_pic_file_{$index}' type='file' name='nksub_pic_{$index}' value='{$options['nksub_pic_'.$index]}' /> <input name='Submit' type='submit' class='button-primary' value='Upload' />";
	}
	echo " <input id='nksub_pic_{$index}' name='nksub_options[nksub_pic_{$index}]' size='100' type='hidden' value='{$options['nksub_pic_'.$index]}' style='' />";
}

function nksub_image_bg_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
  $bg = $options['nksub_image_bg_' . $index];
	$isCustom = $bg === 'custom';

	if ($bg !== 'none') {
		if($bg === 'custom') {
			$bgstyle = 'background-image: url(' . $options['nksub_custom_bg_' . $index] . ')';
		} else {
			$bgstyle = 'background-image: url(' . plugins_url('/img/bg/' . $options['nksub_image_bg_' . $index]. '.jpg', __FILE__) . ')';
		}
	} else {
		$bgstyle = '';
	}

    echo "<select id='nksub_image_bg_{$index}' name='nksub_options[nksub_image_bg_{$index}]'>
    <option value='none' " . ($bg === 'none' ? 'selected="selected"' : '') . ">None</option>
    <option value='custom' " . ($bg === 'custom' ? 'selected="selected"' : '') . ">My custom background</option>
    <option value='blur1' " . ($bg === 'blur1' ? 'selected="selected"' : '') . ">Blurred #1</option>
    <option value='blur2' " . ($bg === 'blur2' ? 'selected="selected"' : '') . ">Blurred #2</option>
    <option value='blur3' " . ($bg === 'blur3' ? 'selected="selected"' : '') . ">Blurred #3</option>
    <option value='blur4' " . ($bg === 'blur4' ? 'selected="selected"' : '') . ">Blurred #4</option>
    <option value='blur5' " . ($bg === 'blur5' ? 'selected="selected"' : '') . ">Blurred #5</option>
    <option value='blur6' " . ($bg === 'blur6' ? 'selected="selected"' : '') . ">Blurred #6</option>
    <option value='blur7' " . ($bg === 'blur7' ? 'selected="selected"' : '') . ">Blurred #7</option>
    <option value='blur8' " . ($bg === 'blur8' ? 'selected="selected"' : '') . ">Blurred #8</option>
    <option value='blur9' " . ($bg === 'blur9' ? 'selected="selected"' : '') . ">Blurred #9</option>
    <option value='blur10' " . ($bg === 'blur10' ? 'selected="selected"' : '') . ">Blurred #10</option>
    <option value='blur11' " . ($bg === 'blur11' ? 'selected="selected"' : '') . ">Blurred #11</option>
    <option value='blur12' " . ($bg === 'blur12' ? 'selected="selected"' : '') . ">Blurred #12</option>
    <option value='blur13' " . ($bg === 'blur13' ? 'selected="selected"' : '') . ">Blurred #13</option>
    <option value='blur14' " . ($bg === 'blur14' ? 'selected="selected"' : '') . ">Blurred #14</option>
    <option value='blur15' " . ($bg === 'blur15' ? 'selected="selected"' : '') . ">Blurred #15</option>
    <option value='pattern1' " . ($bg === 'pattern1' ? 'selected="selected"' : '') . ">Pattern #1</option>
    <option value='pattern2' " . ($bg === 'pattern2' ? 'selected="selected"' : '') . ">Pattern #2</option>
    <option value='pattern3' " . ($bg === 'pattern3' ? 'selected="selected"' : '') . ">Pattern #3</option>
    <option value='pattern4' " . ($bg === 'pattern4' ? 'selected="selected"' : '') . ">Pattern #4</option>
    <option value='pattern5' " . ($bg === 'pattern5' ? 'selected="selected"' : '') . ">Pattern #5</option>
    <option value='pattern6' " . ($bg === 'pattern6' ? 'selected="selected"' : '') . ">Pattern #6</option>
    <option value='pattern7' " . ($bg === 'pattern7' ? 'selected="selected"' : '') . ">Pattern #7</option>
    <option value='pattern8' " . ($bg === 'pattern8' ? 'selected="selected"' : '') . ">Pattern #8</option>
    <option value='pattern9' " . ($bg === 'pattern9' ? 'selected="selected"' : '') . ">Pattern #9</option>
    <option value='pattern10' " . ($bg === 'pattern10' ? 'selected="selected"' : '') . ">Pattern #10</option>
    <option value='pattern11' " . ($bg === 'pattern11' ? 'selected="selected"' : '') . ">Pattern #11</option>
    <option value='pattern12' " . ($bg === 'pattern12' ? 'selected="selected"' : '') . ">Pattern #12</option>
    <option value='pattern13' " . ($bg === 'pattern13' ? 'selected="selected"' : '') . ">Pattern #13</option>
    <option value='pattern14' " . ($bg === 'pattern14' ? 'selected="selected"' : '') . ">Pattern #14</option>
    <option value='pattern15' " . ($bg === 'pattern15' ? 'selected="selected"' : '') . ">Pattern #15</option>
    </select>";

	echo "
		<div id='nksub_theme_preview_{$index}'>
        <p>Background preview:</p>
        <div class='nksub_theme_preview' style='{$bgstyle}'>
            <div class='nksub_sidebar_cont_scrollable'>
                <div class='nksub_sidebar_cont shrinked'>
                    <div class='nksub_sidebar_content'>
                    </div>
                </div>
            </div>
        </div>
	</div>
	";

}

function nksub_custom_bg_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
    if (empty($options['nksub_custom_bg_' .$index])) {
        echo "<input id='nksub_custom_bg_{$index}' type='file' name='nksub_custom_bg_{$index}' value='{$options['nksub_custom_bg_'.$index]}' /> <input name='Submit' type='submit' class='button-primary' value='Upload' />";
        echo "<br><br><label for='nksub_custom_bg_url'>or use URL:</label> <input id='nksub_custom_bg_url_{$index}' name='nksub_options[nksub_custom_bg_{$index}]' size='100' type='text' value='{$options['nksub_custom_bg_' . $index]}' style='' />";
    } else {
//        echo '<div class="nksub_custom_bg" ><img src="' . $options['nksub_custom_bg_' . $index] . '" alt=""/></div>';
        echo "<input id='nksub_custom_bg_{$index}' type='file' name='nksub_custom_bg_{$index}' value='{$options['nksub_custom_bg_' . $index]}' /><input name='Submit' type='submit' class='button-primary' value='Upload' /><br><br>";
	      echo "<label for='nksub_custom_bg_url_{$index}'>Background image URL:</label><br><br><input id='nksub_custom_bg_url_{$index}' name='nksub_options[nksub_custom_bg_{$index}]' size='100' type='text' value='{$options['nksub_custom_bg_' . $index]}' style='' />";
    }
}


function nksub_show_lining_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_show_lining_' . $index] === 'yes' ? 'checked="checked"' : '';
	echo "<p><input id='nksub_show_lining_{$index}' name='nksub_options[nksub_show_lining_{$index}]' type='checkbox' {$checked1} value='yes' /> <label for='nksub_show_lining_{$index}'>Show container</label></p>";
}

function nksub_show_icons_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_show_icons_' . $index] === 'yes' ? 'checked="checked"' : '';
	echo "<p><input id='nksub_show_icons_{$index}' name='nksub_options[nksub_show_icons_{$index}]' type='checkbox' {$checked1} value='yes' /> <label for='nksub_show_icons_{$index}'>Show icons</label></p>";
}

function nksub_form_locker_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_form_locker_' . $index] === 'yes' ? 'checked="checked"' : '';
	echo "<p><input id='nksub_form_locker_{$index}' name='nksub_options[nksub_form_locker_{$index}]' type='checkbox' {$checked1} value='yes' /> <label for='nksub_form_locker_{$index}'>Lock exit (recommended to make notice for user about this)</label></p>";
}
function nksub_form_close_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_form_close_' . $index] === 'yes' ? 'checked="checked"' : '';
	echo "<p><input id='nksub_form_close_{$index}' name='nksub_options[nksub_form_close_{$index}]' type='checkbox' {$checked1} value='yes' /> <label for='nksub_form_close_{$index}'>Auto close</label></p>";
}

function nksub_gamma_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_gamma_' . $index] === 'light' ? 'checked="checked"' : '';
	$checked2 = $options['nksub_gamma_' . $index] === 'dark' ? 'checked="checked"' : '';

	echo "<p><input id='nksub_gamma_light_{$index}' name='nksub_options[nksub_gamma_{$index}]' type='radio' {$checked1} value='light' /> <label for='nksub_gamma_light_{$index}'>Light (good for darker backgrounds)</label></p>";
	echo "<p><input id='nksub_gamma_dark_{$index}' name='nksub_options[nksub_gamma_{$index}]' type='radio' {$checked2} value='dark' /> <label for='nksub_gamma_dark_{$index}'>Dark</label></p>";
}

function nksub_form_scroll_str ($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$checked1 = $options['nksub_form_scroll_' . $index] === 'start' ? 'checked="checked"' : '';
	$checked2 = $options['nksub_form_scroll_' . $index] === 'pageend' ? 'checked="checked"' : '';
	$checked3 = $options['nksub_form_scroll_' . $index] === 'after' ? 'checked="checked"' : '';
	$checked4 = $options['nksub_form_scroll_' . $index] === 'before' ? 'checked="checked"' : '';
	$checked5 = $options['nksub_form_scroll_' . $index] === 'percent' ? 'checked="checked"' : '';

	echo "<p><input id='nksub_form_scroll_start_{$index}' name='nksub_options[nksub_form_scroll_{$index}]' type='radio' {$checked1} value='start' /> <label for='nksub_form_scroll_start_{$index}'>User does first scroll</label></p>";
	echo "<p><input id='nksub_form_scroll_pageend_{$index}' name='nksub_options[nksub_form_scroll_{$index}]' type='radio' {$checked2} value='pageend' /> <label for='nksub_form_scroll_pageend_{$index}'>User reaches the end of page</label></p>";
	echo "<p><input id='nksub_form_scroll_after_{$index}' name='nksub_options[nksub_form_scroll_{$index}]' type='radio' {$checked3} value='after' /> <label for='nksub_form_scroll_after_{$index}'>User scrolls to the end of element <input placeholder='valid CSS selector(s)' type='text' name='nksub_options[nksub_sel_after_{$index}]' value='{$options['nksub_sel_after_'.$index]}' /></label></p>";
	echo "<p><input id='nksub_form_scroll_before_{$index}' name='nksub_options[nksub_form_scroll_{$index}]' type='radio' {$checked4} value='before' /> <label for='nksub_form_scroll_before_{$index}'>User scrolls till whole element is in viewport <input placeholder='valid CSS selector(s)' type='text' name='nksub_options[nksub_sel_before_{$index}]' value='{$options['nksub_sel_before_'.$index]}'/></label></p>";
	echo "<p><input id='nksub_form_scroll_percent_{$index}' name='nksub_options[nksub_form_scroll_{$index}]' type='radio' {$checked5} value='percent' /> <label for='nksub_form_scroll_percent_{$index}'>User scrolls certain percentage of page <input size='3' type='text' name='nksub_options[nksub_sel_percent_{$index}]' value='{$options['nksub_sel_percent_'.$index]}'/> %</label></p>";
}

function nksub_heading_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$val = htmlentities($options['nksub_heading_'.$index], ENT_QUOTES, "UTF-8");

	echo " <input id='nksub_heading_{$index}' name='nksub_options[nksub_heading_{$index}]' size='100' type='text' value='{$val}' style='' />";
}

function nksub_subheading_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$val = htmlentities($options['nksub_subheading_'.$index], ENT_QUOTES, "UTF-8");
    echo "<input id='nksub_subheading_{$index}' name='nksub_options[nksub_subheading_{$index}]'  size='100' type='text' value='{$val}' style='' />";
}

function nksub_callback_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$val = htmlentities($options['nksub_callback_'.$index], ENT_QUOTES);
    echo " <textarea cols='100' rows='10' id='nksub_callback_{$index}' placeholder='Valid JS code' name='nksub_options[nksub_callback_{$index}]'>".$val."</textarea>";
}

function nksub_form_redirect_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
    echo " <input id='nksub_form_redirect_{$index}' placeholder='Full URL to redirect' name='nksub_options[nksub_form_redirect_{$index}]' size='100' type='text' value='{$options['nksub_form_redirect_'.$index]}' style='' />";
}

function nksub_cta_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
  echo " <input id='nksub_cta_{$index}' name='nksub_options[nksub_cta_{$index}]' size='100' type='text' value='{$options['nksub_cta_'.$index]}' style='' />";
}

function nksub_notice_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	$val = htmlentities($options['nksub_notice_'.$index], ENT_QUOTES);

	echo "<textarea cols='100' rows='10' id='nksub_notice_{$index}' name='nksub_options[nksub_notice_{$index}]' >" . $val . "</textarea>";
}

function nksub_avatar_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_avatar_{$index}' name='nksub_options[nksub_avatar_{$index}]' size='100' type='text' value='{$options['nksub_avatar_'.$index]}' style='' />";
}

function nksub_facebook_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_facebook_{$index}' name='nksub_options[nksub_facebook_{$index}]' size='100' type='text' value='{$options['nksub_facebook_'.$index]}' style='' />";
}

function nksub_twitter_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_twitter_{$index}' name='nksub_options[nksub_twitter_{$index}]' size='100' type='text' value='{$options['nksub_twitter_'.$index]}' style='' />";
}


function nksub_pinterest_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_pinterest_{$index}' name='nksub_options[nksub_pinterest_{$index}]' size='100' type='text' value='{$options['nksub_pinterest_'.$index]}' style='' />";
}
function nksub_youtube_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_youtube_{$index}' name='nksub_options[nksub_youtube_{$index}]' size='100' type='text' value='{$options['nksub_youtube_'.$index]}' style='' />";
}
function nksub_instagram_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_instagram_{$index}' name='nksub_options[nksub_instagram_{$index}]' size='100' type='text' value='{$options['nksub_instagram_'.$index]}' style='' />";
}
function nksub_linkedin_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_linkedin_{$index}' name='nksub_options[nksub_linkedin_{$index}]' size='100' type='text' value='{$options['nksub_linkedin_'.$index]}' style='' />";
}

function nksub_gplus_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_gplus_{$index}' name='nksub_options[nksub_gplus_{$index}]' size='100' type='text' value='{$options['nksub_gplus_'.$index]}' style='' />";
}
function nksub_rss_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_rss_{$index}' name='nksub_options[nksub_rss_{$index}]' size='100' type='text' value='{$options['nksub_rss_'.$index]}' style='' />";
}

function nksub_form_timeout_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_form_timeout_{$index}' name='nksub_options[nksub_form_timeout_{$index}]' size='3' type='text' value='{$options['nksub_form_timeout_'.$index]}' style='' /> second(s)";
}

function nksub_form_days_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];
	echo " <input id='nksub_form_days_{$index}' name='nksub_options[nksub_form_days_{$index}]' size='3' type='text' value='{$options['nksub_form_days_'.$index]}' style='' /> day(s)";
}


function nksub_label_color_str() {
	$options = nksub_get_options();

	echo "<input id='nksub_label_color' data-color-format='rgba' name='nksub_options[nksub_label_color]' type='text' value='{$options['nksub_label_color']}' style='' />
	<script>

		jQuery(function(){
			var preview = jQuery('#nksub_button_preview');

			var opts = {
		     previewontriggerelement: true,
		     previewformat: 'rgba',
		     flat: false,
		     color: '{$options['nksub_label_color']}',
		     customswatches: 'label',
		     swatches: [
		       '#50E3C2',
		       'a3503c',
		       '925873',
		       '927758',
		       '589272',
		       '588c92',
		       '2bb1c0',
		       '2b8ac0',
		       'e96701',
		       'c02b74'
		     ],
		     order: {
		         rgb: 1,
		         opacity: 2,
		         preview: 3
		     },
		     onchange: function(container, color) {
		      preview.find('.fa:not(.fa-inverse)').css('color', color.tiny.toRgbString())
		     }
   };
			jQuery('#nksub_label_color').ColorPickerSliders(opts);
		});

</script>
";

}

function nksub_lining_bg_str($args) {
	$options = nksub_get_options();
	$index = $args["index"];

	echo "<input id='nksub_lining_bg_{$index}' data-color-format='rgba' name='nksub_options[nksub_lining_bg_{$index}]' type='text' value='{$options['nksub_lining_bg_'.$index]}' style='' />
	<script>

		jQuery(function(){

			var opts = {
		     previewontriggerelement: true,
		     previewformat: 'rgba',
		     flat: false,
		     color: '{$options['nksub_lining_bg_'.$index]}',
		     swatches: [
		       '#50E3C2',
		       'a3503c',
		       '925873',
		       '927758',
		       '589272',
		       '588c92',
		       '2bb1c0',
		       '2b8ac0',
		       'e96701',
		       'c02b74'
		     ],
		     order: {
		         rgb: 1,
		         opacity: 2,
		         preview: 3
		     }
   };
			jQuery('#nksub_lining_bg_{$index}').ColorPickerSliders(opts);
		});

</script>
";

}

function nksub_tooltip_color_str() {
	$options = nksub_get_options();

	echo "<input id='nksub_tooltip_color' data-color-format='rgba' name='nksub_options[nksub_tooltip_color]' type='text' value='{$options['nksub_tooltip_color']}' style='' />
	<script>

		jQuery(function(){

			var opts = {
		     previewontriggerelement: true,
		     previewformat: 'rgba',
		     flat: false,
		     color: '{$options['nksub_tooltip_color']}',
		     customswatches: 'tooltip',
		     swatches: [
		       '#50E3C2',
		       'a3503c',
		       '925873',
		       '927758',
		       '589272',
		       '588c92',
		       '2bb1c0',
		       '2b8ac0',
		       'e96701',
		       'c02b74'
		     ],
		     order: {
		         rgb: 1,
		         opacity: 2,
		         preview: 3
		     }
   };
			jQuery('#nksub_tooltip_color').ColorPickerSliders(opts);
		});

</script>
";

}

function nksub_label_style_str() {
	$options = nksub_get_options();
	$val = $options['nksub_label_style'];

	echo "<div id='nksub_button_preview'><span class='fa-stack fa-lg fa-{$options['nksub_label_size']}'> <i class='fa icon-{$options['nksub_label_shape']} fa-stack-2x'></i> <i class='fa icon-{$options['nksub_label_style']} fa-stack-1x fa-inverse'></i> </span></div>";
	echo "<select id='nksub_label_style' name='nksub_options[nksub_label_style]'>
		 <option value='paper-1' " . ($val === 'paper-1' ? 'selected="selected"' : '') . ">Paper plane 1</option>
		 <option value='paper-2' " . ($val === 'paper-2' ? 'selected="selected"' : '') . ">Paper plane 2</option>
		 <option value='paper-3' " . ($val === 'paper-3' ? 'selected="selected"' : '') . ">Paper plane 3</option>
		 <option value='paper-4' " . ($val === 'paper-4' ? 'selected="selected"' : '') . ">Paper plane 4</option>
		 <option value='paper-5' " . ($val === 'paper-5' ? 'selected="selected"' : '') . ">Paper plane 5</option>
		 <option value='mail-1' " . ($val === 'mail-1' ? 'selected="selected"' : '') . ">Mail 1</option>
		 <option value='mail-2' " . ($val === 'mail-2' ? 'selected="selected"' : '') . ">Mail 2</option>
		 <option value='mail-3' " . ($val === 'mail-3' ? 'selected="selected"' : '') . ">Mail 3</option>
		 <option value='mail-4' " . ($val === 'mail-4' ? 'selected="selected"' : '') . ">Mail 4</option>
		 <option value='mail-5' " . ($val === 'mail-5' ? 'selected="selected"' : '') . ">Mail 5</option>
		 <option value='mail-6' " . ($val === 'mail-6' ? 'selected="selected"' : '') . ">Mail 6</option>
		 <option value='mail-7' " . ($val === 'mail-7' ? 'selected="selected"' : '') . ">Mail 7</option>
		 <option value='mail-8' " . ($val === 'mail-8' ? 'selected="selected"' : '') . ">Mail 8</option>
		 <option value='mail-9' " . ($val === 'mail-9' ? 'selected="selected"' : '') . ">Mail 9</option>
		 <option value='mail-10' " . ($val === 'mail-10' ? 'selected="selected"' : '') . ">Mail 10</option>
 </select>";
}

function nksub_label_tooltip_str() {
	$options = nksub_get_options();
	$val = $options['nksub_label_tooltip'];

	echo "<select id='nksub_label_tooltip' name='nksub_options[nksub_label_tooltip]'>
     <option value='hover' " . ($val === 'hover' ? 'selected="selected"' : '') . ">On button hover</option>
		 <option value='visible' " . ($val === 'visible' ? 'selected="selected"' : '') . ">Always visible</option>
 		 <option value='none' " . ($val === 'none' ? 'selected="selected"' : '') . ">None</option>
 </select>";
}

function nksub_mail_type_str() {
	$options = nksub_get_options();
	$val = $options['nksub_mail_type'];

	$out = "<select id='nksub_mail_type' name='nksub_options[nksub_mail_type]'>
     <option value='email' " . ($val === 'email' ? 'selected="selected"' : '') . ">Email</option>
		 <option value='mc' " . ($val === 'mc' ? 'selected="selected"' : '') . ">MailChimp</option>
 		 <option value='gr' " . ($val === 'gr' ? 'selected="selected"' : '') . ">Get Response</option>
 		 <option value='cc' " . ($val === 'cc' ? 'selected="selected"' : '') . ">Constant Contact</option>
 		 <option value='ic' " . ($val === 'ic' ? 'selected="selected"' : '') . ">iContact</option>
 		 <option value='bm' " . ($val === 'bm' ? 'selected="selected"' : '') . ">Benchmark Mail</option>
     	 <option value='aw' " . ($val === 'aw' ? 'selected="selected"' : '') . ">AWeber</option>
		 <option value='mr' " . ($val === 'mr' ? 'selected="selected"' : '') . ">MailRelay</option>
		 <option value='eg' " . ($val === 'eg' ? 'selected="selected"' : '') . ">E-Goi</option>
		 <option value='mmi' " . ($val === 'mmi' ? 'selected="selected"' : '') . ">MadMimi</option>
		 <option value='cm' " . ($val === 'cm' ? 'selected="selected"' : '') . ">CampaignMonitor</option>
		 <option value='fm' " . ($val === 'fm' ? 'selected="selected"' : '') . ">FreshMail</option>";
    if(function_exists('mymail_subscribe')) $out .= "<option value='mm' " . ($val === 'mm' ? 'selected="selected"' : '') . ">MyMail</option>"; # Only show if plugin is installed
	 if(class_exists('WYSIJA')) $out .= "<option value='mp' " . ($val === 'mp' ? 'selected="selected"' : '') . ">MailPoet</option>"; # Only show if plugin is installed
    $out .= "</select>";
    echo $out;
	// 		 <option value='none' " . ($val === 'none' ? 'selected="selected"' : '') . ">Benchmark Mail</option>

}

function nksub_label_tooltip_text_str() {
	$options = nksub_get_options();
	echo " <input id='nksub_label_tooltip_text' name='nksub_options[nksub_label_tooltip_text]' size='10' type='text' value='{$options['nksub_label_tooltip_text']}' style='' />";
}

function nksub_metro_str() {
	$options = nksub_get_options();
	$style = $options['nksub_metro'];
	$first_checked = $style == 'yes' ? 'checked="checked"' : '';

	echo "
	<p><input id='nksub_metro' name='nksub_options[nksub_metro]' type='checkbox' value='yes' {$first_checked} style='' /> <label for='nksub_metro'>Metro turned on</label></p>
	";
	echo "
	  <script>
	  jQuery(function(){

		var check = jQuery('#nksub_metro');

	  var icons = jQuery('#nksub_button_preview .fa-stack');
	  var init = true;
	  check.change(function() {
		  var checked = this.checked;
	    icons.each(function(){
	        var preview = jQuery(this);
	        var back = preview.find('i:first');
	        var fore = preview.find('i:last');
	        var color;
	        var css;

	        if(checked) {
	        	        	        	  jQuery('body').addClass('metro')

	            color = back.css('color');
	            css = {'background-color': color};
	            back.css(css);
	        } else {
	        	        	  jQuery('body').removeClass('metro')

	            color = fore.css('color');
	            back.css('background-color', '');
	        }

	        init = false;
	    })

	  });

	  			if (check.is(':checked')) check.change()

		 })
	   </script>
	   ";
}

function nksub_label_invert_str() {
	$options = nksub_get_options();
	$style = $options['nksub_label_invert'];
	$first_checked = $style == 'yes' ? 'checked="checked"' : '';

	echo "
	<p><input id='nksub_label_invert' name='nksub_options[nksub_label_invert]' type='checkbox' value='yes' {$first_checked} style='' /> <label for='nksub_label_invert'>Invert colors</label></p>
	";
	echo "
	  <script>
	  jQuery(function(){
	  	  var check = jQuery('#nksub_label_invert');

		  var icons = jQuery('#nksub_button_preview .fa-stack')
		  check.change(function() {
		  var checked = this.checked;

		  if (checked) {
		  	jQuery('#nksub_label_stroke').attr('checked', false).change();
		  }
	    icons.each(function(){
	        var preview = jQuery(this);
	        var back = preview.find('i:first');
	        var fore = preview.find('i:last');
	        var color;
	        if(checked) {
	        		jQuery('body').addClass('inverted')
	            color = back.css('color');
	            fore.removeClass('fa-inverse').css('color', color);
	            back.addClass('fa-inverse').css('color', '');
	        } else {
	        	  jQuery('body').removeClass('inverted')
	            color = fore.css('color');
	            back.removeClass('fa-inverse').css('color', color);
	            fore.addClass('fa-inverse').css('color', '');
	        }
	    })

	    });

			if (check.is(':checked')) check.change()

	  })
	   </script>
	   ";
}

function nksub_label_size_str() {
	$options = nksub_get_options();
	$val = $options['nksub_label_size'];

	echo "<select id='nksub_label_size' name='nksub_options[nksub_label_size]'>
		 <option value='1x' " . ($val === '1x' ? 'selected="selected"' : '') . ">1x</option>
		 <option value='2x' " . ($val === '2x' ? 'selected="selected"' : '') . ">2x</option>
		 <option value='3x' " . ($val === '3x' ? 'selected="selected"' : '') . ">3x</option>
 </select>";
}

function nksub_label_shape_str() {
	$options = nksub_get_options();
	$val = $options['nksub_label_shape'];

	echo "<select id='nksub_label_shape' name='nksub_options[nksub_label_shape]'>
		 <option value='circle' " . ($val === 'circle' ? 'selected="selected"' : '') . ">Circle</option>
		 <option value='square' " . ($val === 'square' ? 'selected="selected"' : '') . ">Rounded square</option>
 </select>";
}

function nksub_label_top_str() {
	$options = nksub_get_options();
	echo " <input id='nksub_label_top' name='nksub_options[nksub_label_top]' size='10' type='text' value='{$options['nksub_label_top']}' style='' />";
}

function nksub_label_top_mob_str() {
	$options = nksub_get_options();
	echo " <input id='nksub_label_top_mob' name='nksub_options[nksub_label_top_mob]' size='10' type='text' value='{$options['nksub_label_top_mob']}' style='' />";
}

function nksub_label_vis_str() {
	$options = nksub_get_options();
	$val = $options['nksub_label_vis'];
	$first_checked = $val == 'visible' ? 'checked="checked"' : '';
  $sec_checked = $val == 'hidden' ? 'checked="checked"' : '';
//	$third_checked = $val == 'hidden_500' ? 'checked="checked"' : '';
	$forth_checked = $val == 'scroll' ? 'checked="checked"' : '';
	$fifth_checked = $val == 'scroll_into' ? 'checked="checked"' : '';

	echo "
	<p><input id='nksub_label_vis_visible' name='nksub_options[nksub_label_vis]'  type='radio' value='visible' {$first_checked} style='' /> <label for='nksub_label_vis_visible'>Visible</label></p>
	<p><input id='nksub_label_vis_hidden' name='nksub_options[nksub_label_vis]'  type='radio' value='hidden' {$sec_checked} style='' /> <label for='nksub_label_vis_hidden'>Don't show it</label></p>
	<p><input id='nksub_label_vis_scroll' name='nksub_options[nksub_label_vis]'  type='radio' value='scroll' {$forth_checked} style='' /> <label for='nksub_label_vis_scroll'>Fade in label only after user scrolls</label></p>
	<p><input id='nksub_label_vis_scroll_into' name='nksub_options[nksub_label_vis]'  type='radio' value='scroll_into' {$fifth_checked} style='' /> <label for='nksub_label_vis_scroll_into'>Fade in label only after element with selector scrolls into view.</label><br/><br/><input type='text' placeholder='valid CSS selector' id='nksub_label_vis_selector' value='{$options['nksub_label_vis_selector']}' name='nksub_options[nksub_label_vis_selector]'>
	";
}

function nksub_togglers_str()
{
	$options = nksub_get_options();
	echo "<input id='nksub_togglers' name='nksub_options[nksub_togglers]' type='text' value='{$options['nksub_togglers']}' style='' />";
}

function nksub_label_mouseover_str() {
	$options = nksub_get_options();
	$style = $options['nksub_label_mouseover'];
	$first_checked = $style == 'yes' ? 'checked="checked"' : '';

	echo "
	<p><input id='nksub_label_mouseover' name='nksub_options[nksub_label_mouseover]' type='checkbox' value='yes' {$first_checked} style='' /> <label for='nksub_label_mouseover'>Expose form on trigger mouseover</label></p>
	";
}

function nksub_invert_style_str() {
	$options = nksub_get_options();
	$style = $options['nksub_invert_style'];
	$first_checked = $style == 'invert' ? 'checked="checked"' : '';

	echo "
	<p><input id='nksub_invert_style' name='nksub_options[nksub_invert_style]' type='checkbox' value='invert' {$first_checked} style='' /> <label for='nksub_invert_style'>Invert button font color (useful with light color schemes)</label></p>
	";
	echo "<script>
	jQuery('#nksub_invert_style').change(function() {
	var t = jQuery(this).closest('.settings-form-wrapper');
	    if(this.checked) {
	        t.addClass('nksub_invert');
	    } else {
	        t.removeClass('nksub_invert');
	    }
	}).change();
	</script>";
}

function nksub_show_social_str() {
	$options = nksub_get_options();
  $vis = $options['nksub_show_social'];
 echo "<select id='nksub_show_social' name='nksub_options[nksub_show_social]'>
 <option value='show' " . ($vis === 'show' ? 'selected="selected"' : '') . ">Yes</option>
 <option value='hide' " . ($vis === 'hide' ? 'selected="selected"' : '') . ">No</option>
 </select>";
	echo "<script>
	jQuery('#nksub_show_social').change(function() {
	var val = jQuery(this).val();
		var t = jQuery(this).closest('.settings-form-wrapper');
	    if(val === 'show') {
	        t.removeClass('nksub_hide_social');
	    } else {
	        t.addClass('nksub_hide_social');
	    }
	}).change();
	</script>";
}

function nksub_custom_css_str()
{
    $options = nksub_get_options();
    echo "<textarea cols='100' rows='10' id='nksub_custom_css' name='nksub_options[nksub_custom_css]' >" . $options['nksub_custom_css'] . "</textarea>";
}

function nksub_fade_content_str () {
    $options = nksub_get_options();
	  $light_checked = $options['nksub_fade_content'] == 'light' ? 'checked="checked"' : '';
    $dark_checked = $options['nksub_fade_content'] == 'dark' ? 'checked="checked"' : '';
    $none_checked = $options['nksub_fade_content'] == 'none' ? 'checked="checked"' : '';
	  echo "<p><input id='nksub_fade_content_light' name='nksub_options[nksub_fade_content]' type='radio' {$light_checked} value='light' style='' /> <label for='nksub_fade_content_light'>Light overlay</label></p>";
   	echo "<p><input id='nksub_fade_content_dark' name='nksub_options[nksub_fade_content]' type='radio' {$dark_checked} value='dark' style='' /> <label for='nksub_fade_content_dark'>Dark overlay</label></p>";
	  echo "<p><input id='nksub_fade_content_none' name='nksub_options[nksub_fade_content]' type='radio' {$none_checked} value='none' style='' /> <label for='nksub_fade_content_none'>Don't fade (recommended if you experience animation lags in Chrome browser on Windows)</label></p>";

}
function nksub_sidebar_pos_str () {
    $options = nksub_get_options();
    $left_checked = $options['nksub_sidebar_pos'] == 'left' ? 'checked="checked"' : '';
    $right_checked = $options['nksub_sidebar_pos'] == 'right' ? 'checked="checked"' : '';

   	echo "<p><input id='nksub_sidebar_pos_left' name='nksub_options[nksub_sidebar_pos]' type='radio' {$left_checked} value='left' style='' /> <label for='nksub_sidebar_pos_left'></label></p>";
   	echo "<p><input id='nksub_sidebar_pos_right' name='nksub_options[nksub_sidebar_pos]' type='radio' {$right_checked} value='right' style='' /> <label for='nksub_sidebar_pos_right'></label></p>";
}



if ( !function_exists('imsanity_get_source')) {

/*
Plugin Name: Imsanity
Plugin URI: http://verysimple.com/products/imsanity/
Description: Imsanity stops insanely huge image uploads
Author: Jason Hinkle
Version: 2.2.5
Author URI: http://verysimple.com/
*/

define('IMSANITY_VERSION','2.2.5');
define('IMSANITY_SCHEMA_VERSION','1.1');

define('IMSANITY_DEFAULT_MAX_WIDTH', 230);
define('IMSANITY_DEFAULT_MAX_HEIGHT', 230);
define('IMSANITY_DEFAULT_BMP_TO_JPG',1);
define('IMSANITY_DEFAULT_QUALITY',90);

define('IMSANITY_SOURCE_POST',1);
define('IMSANITY_SOURCE_LIBRARY',2);
define('IMSANITY_SOURCE_OTHER',4);


/**
 * Inspects the request and determines where the upload came from
 * @return IMSANITY_SOURCE_POST | IMSANITY_SOURCE_LIBRARY | IMSANITY_SOURCE_OTHER
 */
function imsanity_get_source()
{
	return array_key_exists('post_id', $_REQUEST)
		?  ($_REQUEST['post_id'] == 0 ? IMSANITY_SOURCE_LIBRARY : IMSANITY_SOURCE_POST)
		: IMSANITY_SOURCE_OTHER;
}

/**
 * Given the source, returns the max width/height
 *
 * @example:  list($w,$h) = imsanity_get_max_width_height(IMSANITY_SOURCE_LIBRARY);
 * @param int IMSANITY_SOURCE_POST | IMSANITY_SOURCE_LIBRARY | IMSANITY_SOURCE_OTHER
 */
function imsanity_get_max_width_height($source)
{
	$w = IMSANITY_DEFAULT_MAX_WIDTH;
	$h = IMSANITY_DEFAULT_MAX_HEIGHT;
	return array($w,$h);
}




/**
 * If the uploaded image is a bmp this function handles the details of converting
 * the bmp to a jpg, saves the new file and adjusts the params array as necessary
 *
 * @param array $params
 */

	function imsanity_bmp_to_jpg($params)
	{

		// read in the bmp file and then save as a new jpg file.
		// if successful, remove the original bmp and alter the return
		// parameters to return the new jpg instead of the bmp

		//include_once('libs/imagecreatefrombmp.php');

		$bmp = imagecreatefrombmp($params['file']);

		// we need to change the extension from .bmp to .jpg so we have to ensure it will be a unique filename
		$uploads = wp_upload_dir();
		$oldFileName = basename($params['file']);
		$newFileName = basename(str_ireplace(".bmp", ".jpg", $oldFileName));
		$newFileName = wp_unique_filename( $uploads['path'], $newFileName );

		$quality = IMSANITY_DEFAULT_QUALITY;

		if (imagejpeg($bmp,$uploads['path'] . '/' . $newFileName, $quality))
		{
			// conversion succeeded.  remove the original bmp & remap the params
			unlink($params['file']);

			$params['file'] = $uploads['path'] . '/' . $newFileName;
			$params['url'] = $uploads['url'] . '/' . $newFileName;
			$params['type'] = 'image/jpeg';
		}
		else
		{
			unlink($params['file']);

			return wp_handle_upload_error( $oldFileName,
				__("Oh Snap! Imsanity was Unable to process the BMP file.  "
					."If you continue to see this error you may need to disable the BMP-To-JPG "
					."feature in Imsanity settings.", 'imsanity' ) );
		}

		return $params;
	}

/**
 * ################################################################################
 * UTILITIES
 * ################################################################################
 */

/**
 * Util function returns an array value, if not defined then returns default instead.
 * @param Array $array
 * @param string $key
 * @param variant $default
 */
function imsanity_val($arr,$key,$default='')
{
	return isset($arr[$key]) ? $arr[$key] : $default;
}

/**
 * output a fatal error and optionally die
 *
 * @param string $message
 * @param string $title
 * @param bool $die
 */
function imsanity_fatal($message, $title = "", $die = false)
{
	echo ("<div style='margin:5px 0px 5px 0px;padding:10px;border: solid 1px red; background-color: #ff6666; color: black;'>"
		. ($title ? "<h4 style='font-weight: bold; margin: 3px 0px 8px 0px;'>" . $title . "</h4>" : "")
		. $message
		. "</div>");

	if ($die) die();
}

/**
 * Replacement for deprecated image_resize function
 * @param string $file Image file path.
 * @param int $max_w Maximum width to resize to.
 * @param int $max_h Maximum height to resize to.
 * @param bool $crop Optional. Whether to crop image or resize.
 * @param string $suffix Optional. File suffix.
 * @param string $dest_path Optional. New image file path.
 * @param int $jpeg_quality Optional, default is 90. Image quality percentage.
 * @return mixed WP_Error on failure. String with new destination path.
 */
function imsanity_image_resize( $file, $max_w, $max_h, $crop, $suffix = null, $dest_path = null, $jpeg_quality = 90 ) {

	if (function_exists('wp_get_image_editor'))
	{
		// WP 3.5 and up use the image editor

		$editor = wp_get_image_editor( $file );
		if ( is_wp_error( $editor ) )
			return $editor;
		$editor->set_quality( $jpeg_quality );

		$resized = $editor->resize( $max_w, $max_h, $crop );
		if ( is_wp_error( $resized ) )
			return $resized;

		$dest_file = $editor->generate_filename( $suffix, $dest_path );

		// FIX: make sure that the destination file does not exist.  this fixes
		// an issue during bulk resize where one of the optimized media filenames may get
		// used as the temporary file, which causes it to be deleted.
		while (file_exists($dest_file)) {
			$dest_file = $editor->generate_filename('TMP', $dest_path );
		}

		$saved = $editor->save( $dest_file );

		if ( is_wp_error( $saved ) )
			return $saved;

		return $dest_file;
	}
	else
	{
		// wordpress prior to 3.5 uses the old image_resize function
		return image_resize( $file, $max_w, $max_h, $crop, $suffix, $dest_path, $jpeg_quality);
	}
}

}

/**
 * Handler after a file has been uploaded.  If the file is an image, check the size
 * to see if it is too big and, if so, resize and overwrite the original
 * @param Array $params
 */
function nksub_imsanity_handle_upload($params) {

	$options = nksub_get_options();
	for ($i = 1; $i <= $options['nksub_forms']; $i++) {
		if (isset($_FILES['nksub_pic_'.$i]) && ($_FILES['nksub_pic_'.$i]['size'] > 0)) {
			/* debug logging... */
			// file_put_contents ( "debug.txt" , print_r($params,1) . "\n" );

			/*	$option_convert_bmp = IMSANITY_DEFAULT_BMP_TO_JPG;

				if ($params['type'] == 'image/bmp' && $option_convert_bmp)
				{
					$params = imsanity_bmp_to_jpg($params);
				}*/

			// make sure this is a type of image that we want to convert and that it exists
			// @TODO when uploads occur via RPC the image may not exist at this location
			$oldPath = $params['file'];

			if ( (!is_wp_error($params)) && file_exists($oldPath) && in_array($params['type'], array('image/png','image/gif','image/jpeg')))
			{

				// figure out where the upload is coming from
				$source = imsanity_get_source();

				list($maxW,$maxH) = imsanity_get_max_width_height($source);

				list($oldW, $oldH) = getimagesize( $oldPath );

				/* HACK: if getimagesize returns an incorrect value (sometimes due to bad EXIF data..?)
				$img = imagecreatefromjpeg ($oldPath);
				$oldW = imagesx ($img);
				$oldH = imagesy ($img);
				imagedestroy ($img);
				//*/

				/* HACK: an animated gif may have different frame sizes.  to get the "screen" size
				$data = ''; // TODO: convert file to binary
				$header = unpack('@6/vwidth/vheight', $data );
				$oldW = $header['width'];
				$oldH = $header['width'];
				//*/

				if (($oldW > $maxW && $maxW > 0) || ($oldH > $maxH && $maxH > 0))
				{
					$quality = IMSANITY_DEFAULT_QUALITY;


					list($newW, $newH) = wp_constrain_dimensions($oldW, $oldH, $maxW, $maxH);

					// this is wordpress prior to 3.5 (image_resize deprecated as of 3.5)
					//$resizeResult = imsanity_image_resize( $oldPath, $newW, $newH, true, null, null, $quality);
					$resizeResult = imsanity_image_resize( $oldPath, $maxW, $maxH, true, null, null, $quality);

					/* uncomment to debug error handling code: */
					// $resizeResult = new WP_Error('invalid_image', __(print_r($_REQUEST)), $oldPath);

					// regardless of success/fail we're going to remove the original upload
					unlink($oldPath);

					if (!is_wp_error($resizeResult))
					{
						$newPath = $resizeResult;

						// remove original and replace with re-sized image
						rename($newPath, $oldPath);
					}
					else
					{
						// resize didn't work, likely because the image processing libraries are missing
						$params = wp_handle_upload_error( $oldPath ,
							sprintf( __("Oh Snap! Imsanity was unable to resize this image "
								. "for the following reason: '%s'
						.  If you continue to see this error message, you may need to either install missing server"
								. " components or disable the Imsanity plugin."
								. "  If you think you have discovered a bug, please report it on the Imsanity support forum.", 'imsanity' ) ,$resizeResult->get_error_message() ) );

					}
				}

			}
		}
	};

	return $params;

}

/* add filters to hook into uploads */
add_filter( 'wp_handle_upload', 'nksub_imsanity_handle_upload' );
